// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	init = FALSE;
	
	srand( (unsigned)time( NULL ) );

}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_BID, BID);
	DDX_Control(pDX, IDC_MULT, MULT);
	DDX_Control(pDX, IDC_RANGE, RANGE);
	DDX_Control(pDX, IDC_THERM, THERM);
	DDX_Control(pDX, IDC_VOLTS, VOLTS);
	DDX_Control(pDX, IDC_MIX1, MIX1);
	DDX_Control(pDX, IDC_MIX10, MIX10);
	DDX_Control(pDX, IDC_MIX2, MIX2);
	DDX_Control(pDX, IDC_MIX3, MIX3);
	DDX_Control(pDX, IDC_MIX4, MIX4);
	DDX_Control(pDX, IDC_MIX5, MIX5);
	DDX_Control(pDX, IDC_MIX6, MIX6);
	DDX_Control(pDX, IDC_MIX7, MIX7);
	DDX_Control(pDX, IDC_MIX8, MIX8);
	DDX_Control(pDX, IDC_MIX9, MIX9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if (!init) {
		init = TRUE;
		
		SetTimer(1000,55,NULL);
		SetTimer(1010,250,NULL);
		SetTimer(1020,1000,NULL);
		}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_BID, -601 /* DblClick */, OnDblClickBid, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX1, -601 /* DblClick */, OnDblClickMix1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX10, -601 /* DblClick */, OnDblClickMix10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX2, -601 /* DblClick */, OnDblClickMix2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX3, -601 /* DblClick */, OnDblClickMix3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX4, -601 /* DblClick */, OnDblClickMix4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX5, -601 /* DblClick */, OnDblClickMix5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX6, -601 /* DblClick */, OnDblClickMix6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX7, -601 /* DblClick */, OnDblClickMix7, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX8, -601 /* DblClick */, OnDblClickMix8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MIX9, -601 /* DblClick */, OnDblClickMix9, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MULT, -601 /* DblClick */, OnDblClickMult, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_MULT, 2 /* Slide */, OnSlideMult, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_RANGE, 2 /* Slide */, OnSlideRange, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_RANGE, -601 /* DblClick */, OnDblClickRange, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_THERM, 2 /* Slide */, OnSlideTherm, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_THERM, -601 /* DblClick */, OnDblClickTherm, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_VOLTS, -601 /* DblClick */, OnDblClickVolts, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1010);
	KillTimer(1020);
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
float a,b;

	switch (nIDEvent) {
		case 1000: // fast timer 55 msec
		    VOLTS.SetPointerValue(VOLTS.GetPointerValue() + 0.5f*(float) rand()/(float) RAND_MAX - 0.25f);
			
			MULT.SetPointerID(0);
			MULT.SetPointerValue(MULT.GetPointerValue() + 1.0f*(float) rand()/(float) RAND_MAX - 0.5f);
			a = MULT.GetPointerValue();
			
			MULT.SetPointerID(1);
			MULT.SetPointerValue(MULT.GetPointerValue() + 1.0f*(float) rand()/(float) RAND_MAX - 0.5f);
			b = MULT.GetPointerValue();
			
			MULT.SetPointerID(2);
			MULT.SetPointerValue(a * b);
			
			break;
		case 1010: // medium timer 250 msec
		    THERM.SetPointerID(0);
			THERM.SetPointerValue(THERM.GetPointerValue() + 6.0f*(float) rand()/(float) RAND_MAX - 3.0f);
			OnSlideTherm();
			
			break;
		case 1020: // slow timer 1 sec
		    BID.SetPointerID(0); //bid
			BID.SetPointerValue(BID.GetPointerValue() + 0.25f-(float) rand()/(float) RAND_MAX * 0.5f);
			
			if (BID.GetPointerValue() > BID.GetScaleMax())
				BID.SetPointerValue(BID.GetScaleMax());
			else if (BID.GetPointerValue() < BID.GetScaleMin())
				BID.SetPointerValue(BID.GetScaleMin());
			
			BID.SetPointerID(1); //ask
			BID.SetPointerValue(BID.GetPointerValue() + 0.25f-(float) rand()/(float) RAND_MAX * 0.5f);
			
			if (BID.GetPointerValue() > BID.GetScaleMax())
				BID.SetPointerValue(BID.GetScaleMax());
			else if (BID.GetPointerValue() < BID.GetScaleMin())
				BID.SetPointerValue(BID.GetScaleMin());
			
			break;
		};

	CDialog::OnTimer(nIDEvent);
}

void CVCDemoDlg::OnDblClickBid() 
{
	BID.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix1() 
{
	MIX1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix10() 
{
	MIX10.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix2() 
{
	MIX2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix3() 
{
	MIX3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix4() 
{
	MIX4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix5() 
{
	MIX5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix6() 
{
	MIX6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix7() 
{
	MIX7.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix8() 
{
	MIX8.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMix9() 
{
	MIX9.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickMult() 
{
	MULT.ShowPropertyPage();
}

void CVCDemoDlg::OnSlideMult() 
{
float a,b;

    switch(MULT.GetPointerID()) {
        case 0:
            MULT.SetPointerID(0);
            a = MULT.GetPointerValue();
            
            MULT.SetPointerID(1);
            b = MULT.GetPointerValue();
			
            MULT.SetPointerID(2);
            MULT.SetPointerValue(a * b);
			break;
        case 1:
            MULT.SetPointerID(0);
            a = MULT.GetPointerValue();
            
            MULT.SetPointerID(1);
            b = MULT.GetPointerValue();
			
            MULT.SetPointerID(2);
            MULT.SetPointerValue(a * b);
			break;
        case 2:
            MULT.SetPointerID(2);
            a = MULT.GetPointerValue();
            
            MULT.SetPointerID(0);
            MULT.SetPointerValue((float) sqrt(a));
            
            MULT.SetPointerID(1);
            MULT.SetPointerValue((float) sqrt(a));
			break;
		}

}

void CVCDemoDlg::OnSlideRange() 
{
float pstart,pstop;

	switch (RANGE.GetPointerID()) {
        case 0:
            RANGE.SetPointerID(0);
            pstart = RANGE.GetPointerStart();
            pstop = RANGE.GetPointerStop();
            
            RANGE.SetPointerID(1);
            RANGE.SetPointerValue(pstart);
            
            RANGE.SetPointerID(2);
            RANGE.SetPointerValue(pstop);
			break;
        case 1:
            RANGE.SetPointerID(1);
            pstart = RANGE.GetPointerValue();
            
            RANGE.SetPointerID(0);
            if (pstart > RANGE.GetPointerStop())
                pstart = RANGE.GetPointerStop();
            
            RANGE.SetPointerStart(pstart);
            RANGE.SetPointerID(1);
            RANGE.SetPointerValue(pstart);
			break;
        case 2:
            RANGE.SetPointerID(2);
            pstop = RANGE.GetPointerValue();
            
            RANGE.SetPointerID(0);
            if (pstop < RANGE.GetPointerStart())
                pstop = RANGE.GetPointerStart();
            
            RANGE.SetPointerStop(pstop);
            RANGE.SetPointerID(2);
            RANGE.SetPointerValue(pstop);
			break;
		}
}

void CVCDemoDlg::OnDblClickRange() 
{
	RANGE.ShowPropertyPage();
}

void CVCDemoDlg::OnSlideTherm() 
{
float tval;

	//get value of pointer(0)
    THERM.SetPointerID(0);
    tval = THERM.GetPointerValue();
    
    //change band level
    THERM.SetBandID(1);
    THERM.SetBandStop(tval);
    
    //check value of pointer(1)
    THERM.SetPointerID(1);
    if (THERM.GetPointerValue() < tval) 
        THERM.SetPointerValue(tval);
    
    //check value of pointer(2)
    THERM.SetPointerID(2);
    if (THERM.GetPointerValue() > tval)
        THERM.SetPointerValue(tval);

}

void CVCDemoDlg::OnDblClickTherm() 
{
	THERM.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickVolts() 
{
	VOLTS.ShowPropertyPage();
}

void CVCDemoDlg::OnReset() 
{
float tval;

	//get value of pointer(0)
    THERM.SetPointerID(0);
    tval = THERM.GetPointerValue();
    
    //set value of pointer(1)
    THERM.SetPointerID(1);
    THERM.SetPointerValue(tval);
    
    //set value of pointer(2)
    THERM.SetPointerID(2);
    THERM.SetPointerValue(tval);
}
